{$A+,B+,D+,E+,F+,G-,I-,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y-}
{$M 16384,0,655360}

uses
 Objects;

var
 T: Text;
 O: File;
 State: (stRead, stHexErr, stDone);
 F: PBufStream;
 BinSize: Word;

function HexChar(Ch: Char): Byte;
begin
 HexChar := 0;
 if Ch in ['0'..'9'] then HexChar := Byte(Ch) - $30
 else if Ch in ['A'..'F'] then HexChar := Byte(Ch) - $37
      else if Ch in ['a'..'f'] then HexChar := Byte(Ch) - $57
           else State := stHexErr;
end;

function GetHexByte(Var S: String): Byte;
 begin
  GetHexByte := HexChar(S[1]) shl 4 + HexChar(S[2]);
  Delete(S, 1, 2);
 end;

function HexRead(var T: Text; F: PBufStream): Word;
var
 Addr, NewAddr: Word;
 B: Byte;
 W: Word;
 HexLen, CheckSum, HexType, i: Byte;
 S: String;
begin
 Addr := 0;
 while not eof(T) do
  begin
   ReadLn(T, S);
   if S[1] <> ':' then State := stHexErr;
   case State of
    stRead:
     begin
      Delete(S, 1, 1);
      HexLen := GetHexByte(S);
      NewAddr := GetHexByte(S);
      NewAddr := NewAddr shl 8 + GetHexByte(S);

      if NewAddr > Addr then
       begin
         B := $ff;
         while NewAddr > Addr do
          begin
           F^.Write(B, 1);
           inc(Addr);
          end;
       end
      else
      if NewAddr < Addr then
       begin
        F^.Seek(NewAddr);
        Addr := NewAddr;
       end;

      HexType := GetHexByte(S);
      CheckSum := HexLen + Lo(Addr) + Hi(Addr) + HexType;
      if HexType = 1 then State := stDone
      else
       begin
        for i := 0 to HexLen -1 do
         begin
          B := GetHexByte(S);
          inc(CheckSum, B);
          F^.Write(B, 1);
          inc(Addr);
         end;
       end;
      Inc(CheckSum, GetHexByte(S));
      if CheckSum <> 0 then State := stHexErr;
     end;
    stDone:
     HexRead := Addr;
   end; {case}
  end;
end;

begin
 if ParamCount < 2 then
  begin
   WriteLn('HEX2BIN File.Hex File.Bin');
   Halt(0);
  end;
 State := stRead;
 Assign(T, ParamStr(1));
 Reset(T);
 if IOResult <> 0 then
  begin
   WriteLn('File ', ParamStr(1), 'not found.');
   Halt(1);
  end;

 F := New(PBufStream,Init(ParamStr(2), stCreate, 4096));
 if F^.Status <> stOk then
  begin
   WriteLn('Can''t create file ', ParamStr(2), '.');
   Halt(1);
  end;
 BinSize := HexRead(T, F);
 Close(T);
 Dispose(F, Done);
 if State = stHexErr then WriteLn('Error in HEX file ', ParamStr(1), '.')
 else WriteLn(BinSize, ' bytes converted.');
end.